I=double(imread('tumor_pineal.jpg'));
[nf nc]=size(I);
subplot(2,2,1);imshow(I,[0 255]);
title('Imagen Original');
[x y]=ginput(1);
x=round(x);
y=round(y);

T=I(y,x)
delta=9999;

while delta>1

  B=2*(I>T)-1;%marca con +1 los puntos sobre T y con -1 los puntos bajo T
  
  n=sum(B>0);
  p1=sum(((I.*B)>0).*I)/n; %Promedia sólo los puntos sobre T
  n=sum(B<0);
  p2=sum(((I.*B)<0).*I)/n; %Promedia sólo los puntos bajo T
  
  Told=T;
  T=(p1+p2)/2
  delta=abs(Told-T);
  
  I2=(I>T).*I;
  subplot(2,2,2);imshow(I2,[]);
  title('Umbralización Automática');
  pause(1)
  
  subplot(2,2,3);imhist(I/255);
  title('Histograma de Imagen Original');
  subplot(2,2,4);imhist(I2/255);
  title('Histograma de Imagen Umbralizada');
end;
  
  

